

' ***RC-210 Repeater Controller Copyright 2003 by Arcom Communications
' ***Version 4.1 March 10, 2004
'
' ***Please be sure to read your manual for instructions on how to install this update
' ***Issues this version addresses:


'  *************************************
'  **** Changes in Version 4.1  ****
'  *************************************

'New command to allow you to bump the clock time by x seconds. When you enter this command,
'it also stores this value in ERAM. You can then recall this correction factor with new
'macro function #309. You subtract seconds by prefacing your entry with DTMF A

'Examples:

'*5105 2     Add 2 seconds to the current clock time
'*5105 A 4  Subtract 4 seconds from the current clock time
'*5105 0     Clear any correction factor

'Remember that this effect is immediate, yet its value is also stored in ERAM for future use.

'Macro function 309 sets the clock based on the stored correction factor. You can also call 'it from the scheduler
'for example once a day - to compensate for any clock xtal error. For example if you know your clock loses
'1 second every 24 hours, you could schedule to run macro 309 at midnight. This will ensure an accurate clock.

'Also added was a new programming command to turn off the year readback from the Calendar.
'If turned off however and you program the Calendar, the year will be spoken regardless, so
'you know your programming is correct.

'*5102 1 Readback year as part of date
'*5102 0 Don't readback year as part of date

'Macro Functions for Say Year:

'310 Set Readback Year flag ON
'311 Set Readback Year flag OFF

'There are now 3 Tail Messages per port that can be used to call a Message Macro based on the number
'of "tails" that occur (tails of course refers to the time a repeater tranmitter continues to transmit after its
'Courtesy Tone plays). Tail Messages will be spoken right before the tail time expires and before that port's
' transmitter drops. You can program how often the Tail Message will be sent:

'Examples:

' *2112 5   Send Tail Message every 5 tails
' *2112 20  Send Tail Message every 20 tails

'The range is 0 to 254 tails (0 disables the Counter)

'Programing the Tail Message examples:

' *2110 1 01  Program the currently unlocked port's Tail Message #1 to use Message Macro 1
' *2110 3 22  Program the currently unlocked port's Tail Message #2 to use Message Macro 22

'Selecting which Tail Message to use:

' *2111 1   Use Tail Message #1 on the currently unlocked Port
' *2111 3   Use Tail Message # 3 on the currently unlocked Port
' *2111 0   Turn OFF Tail Messages on the currently unlocked Port

 'There is also an Announce Timer that allows a Tail Message to be sent x seconds after
 'COS closure and independent of hang time. This is in addition to the Tail Message counter
 'above. For example, you could program this timer to send the currently selected Tail Message
 '15 minutes after the last COS closure on that port. This timer is programmed in seconds and
 'you may disable it completely by programming it to 0.
 ' Examples:

 ' *1020 60  Send currently selected Tail Message one minute after the last COS closure
 ' *1020 300  Send currently selected Tail Message 5 minutes after the last COS closure
 ' *1020 0     Turn OFF timed Tail Messages

 'The range is 0 (OFF) to 3600 seconds (one hour)

 'There are also new macro functions associated with Tail Messages:

'  312  Port 1 Tail Message OFF
'  313  Port 2 Tail Message OFF
'  314  Port 3 Tail Message OFF

'  315  Port 1 Tail Message 1
'  316  Port 2 Tail Message 1
'  317  Port 3 Tail Message 1

'  318  Port 1 Tail Message 2
'  319  Port 2 Tail Message 2
'  320  Port 3 Tail Message 2

'  321  Port 1 Tail Message 3
'  322  Port 2 Tail Message 3
'  323  Port 3 Tail Message 3
                                                  

************************************************************************************





'  ***********************************
'  **** Changes in Version 4.0  ****
'  ***********************************

'-----------------------------------------------------------

'Many new features including:

'New memory reorganize program, which allows for automatic update to new memory map
'without losing your custom programming.
'Voice ID space increased to 22 words per ID per port
'By default, commands no longer work unless the controller is unlocked. This
'can be changed by remapping functions using macros.
'Changes to ID algorthms to allow voice ID's to be used in Pending IDs
'New speech "phrases" that allow the use of various run-time messages (Good E/A/M,
'for example) in IDs.
'New Message Macros allow the storage of up to 10 words/DVR tracks for use in
'any controller function
'20 DMTF message "memories" can store DTMF sequences to be sent out any Port.
'Priority macros, used to specify importance of Speech Override functions.
'New receiver disable commands.
'Numerous bugs fixed, including Courtesy Tones and debouncing added to alarm
'inputs to prevent falsing.
'Scheduler Setpoints can now be globally cleared.
'Meter High/Low Alarms are implemented, to allow control based on
'over temperature, over voltage, high SWR, etc. Any
'50 new "short" macros (typically used to remap commands for general use but
'may be used for any valid macro use).
'String compression is implemented, resulting in substantial memory savings.
'Ability to redefine lock code and digit used as DTMF terminator
'
'---------------------------------------------------------------------------

'New Commands added to 4.0

'*9010 Define new Lock Code, up to 4 digits
'*9020 Define new DTMF terminator digit


'  ***********************************
'  **** Changes in Version 3.56  ****
'  ***********************************


'--------------------------------------------------------
'New vocabulary support
'
'--------------------------------------------------------
'Fixed minor bug in scheduler
'
'========================================================
'========================================================

'  ***********************************
'  **** Changes in Version 3.55  ****
'  ***********************************

'--------------------------------------------------------
'Fixed bug with PL encode control where it didn't track COS
'properly.

'--------------------------------------------------------
'Fixed bug in Port Activity Timers where timers weren't
'always accurate.

'--------------------------------------------------------
'Changed how time out timers are programmed. They are now
'programmed in seconds.

'---------------------------------------------------------
'Added new commands to control DTMF on a per port basis:

'1151 Port 1 DTMF enabled
'1150 Port 1 DTMF disabled

'2151 Port 2 DTMF enabled
'2150 Port 2 DTMF disabled

'3151 Port 3 DTMF enabled
'3150 Port 3 DTMF disabled

'When DTMF is disabled, that port will only respond to calling
'Macros 35 - 40, or the DTMF enable command. All other commands
'are ignored

'1161 Require CTCSS for DTMF on Port 1
'1160 Do not require CTCSS for DTMF Port 1

'2161 Require CTCSS for DTMF on Port 2
'2160 Do not require CTCSS for DTMF Port 2

'3161 Require CTCSS for DTMF on Port 3
'3160 Do not require CTCSS for DTMF Port 3

'When CTCSS is required, no commands will be accepted without
'CTCSS on that port, regardless of CTCSS/Carrier access selection.

'----------------------------------------------------------
'Changed many of the programming commands, as more room was
'needed. See manual for new list.

'----------------------------------------------------------
'Added new programming command to allow Auxiliary Audio inputs
'to be used in place of Alarm messages

'*2101 <Alarm #> <Use/Not Use> <optional Aux #>

'Alarm 1 through 5
'1 = Use, 0 = Not Use
'Optional Aux # 1 through 3 . Only needed if you program Aux to
'be used for an Alarm message. If you set it to "Not Use"
'(i.e. "0"), you may omit the Aux # entry. See examples below.

'Examples:

'Use Aux 1 for Alarm 2

'*2101 2 1 1

'Don't use any Aux for Alarm 1 (use the speech message)

'*2101 1 0

'Notice that if you choose to not use an aux input for an alarm,
'you can disregard the Aux #.

'-----------------------------------------------------------------
'Changed how alarms work. They no longer call their own speech
'messages, but are now programmed to call a macro.

'*2102 <Alarm # 1-5> <macro # 1-40)

'Example:

'Alarm 2 to call Macro 5 when triggered

'*2102 2 5

'---------------------------------------------------------------
'When in Programming Mode (any Port), you can playback any
'Vocabulary word or DVR track number by entering "123" plus the
'word (or DVR Track #).

'Examples:

'123 002 Play word "Two"
'123 215 Play word "Tonight"
'123 1   Play DVR Track 1
'123 20  Play DVR Track 20

'-----------------------------------------------------------------

'=================================================================
'=================================================================


'  ***********************************
'  **** Changes in Version 3.54  ****
'  ***********************************

'---------------------------------------------------------

'Added the ability to rename macros. Each of the 40 macros may
'now be assigned their own custom code. The default (from the
'factory codes) remain the same.

'*2020 yy xxxxxxxx) yy = 01 - 40 xxxxxxxx = command code

'---------------------------------------------------------

'Moved port assignments for speech from the scheduler programming
'to macro programming, since the scheduler calls macros in the
'first place.

'*4002 mm  <commands> where mm is the macro to be programmed 01 - 40.


'If you use this, the port command must be the first in the macro string.
'Otherwise it will be ignored.

'Port = Additional port to play message
'    1 = Port 1
'    2 = Port 2
'    3 = Port 3
'    12 = Ports 1 & 2
'    13 = Ports 1 & 3
'    23 = Ports 2 & 3
'    123 = All Ports


'----------------------------------------------------------

'Fixed bug where courtesy tones didn't always wait for current
'command acknowledgement before being sent

'----------------------------------------------------------

'Fixed bug in CW speed selection where the cw speed wasn't always
'accurate

'----------------------------------------------------------

'Fixed bug in courtesy tone delay time. Sometimes the programmed
'delay wasn't accurate

'----------------------------------------------------------

'Auxilary Audio Inputs

'There are 3 auxiliary audio inputs that may be used for such things as
'a weather receiver, or autopatch. Each input may be routed to any port's
'transmitter, or all.

'*2080 x y where "x" is the audio input and "y" is the port(s) that is sent
'          the audio

'x = 1 Aux Input 1   y = 1 Port 1
'x = 2 Aux Input 2  y = 2 Port 2
'x = 3 Aux Input 3  y = 3 Port 3
'      y = 12 Ports 1 & 2
'      y = 13 Ports 1 & 3
'      y = 123 Ports 1, 2 & 3


'----------------------------------------------------------------------------

'New function code list - everything after 116 is shifted down one to add
'new Say Date function. Also, Auxiliary Audio and Macro speech direction
'commands were added:

'116 Say Time      146 Auxiliary Audio 1 ON
'117 Say Date      147 Auxiliary Audio 2 ON
'118 Link Port 1 to Port 2   148 Auxiliary Audio 3 ON
'119 Link Port 1 to Port 3   149 Auxiliary Audio 1 OFF
'120 Link Port 2 to Port 3   150 Auxiliary Audio 2 OFF
'121 Link All Ports     151 Auxiliary Audio 3 OFF
'122 Unlink Port 1 from Port 2  152 Alarm 1 ON
'123 Unlink Port 1 from Port 3  152 Alarm 2 ON
'124 Unlink Port 2 from Port 3  154 Alarm 3 ON
'125 UnLink All Ports    155 Alarm 4 ON
'126 Play DVR Track 1    156 Alarm 5 ON
'127 Play DVR Track 2    157 Alarm 1 OFF
'128 Play DVR Track 3    158 Alarm 2 OFF
'129 Play DVR Track 4    159 Alarm 3 OFF
'130 Play DVR Track 5    160 Alarm 4 OFF
'131 Play DVR Track 6    161 Alarm 5 OFF
'132 Play DVR Track 7    162 Speech Out Port 1
'133 Play DVR Track 8    163 Speech Out Port 2
'134 Play DVR Track 9    164 Speech Out Port 3
'135 Play DVR Track 11    165 Speech Out Port 1 & 2
'136 Play DVR Track 11    166 Speech Out Port 1 & 3
'137 Play DVR Track 12    167 Speech Out Port 2 & 3
'138 Play DVR Track 13    168 Speech Out All Ports
'149 Play DVR Track 14
'140 Play DVR Track 15
'141 Play DVR Track 16
'142 Play DVR Track 17
'143 Play DVR Track 18
'144 Play DVR Track 19
'145 Play DVR Track 20
'
'--------------------------------------------------------------------
'--------------------------------------------------------------------

' * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 ' * * * * IMPORTANT! YOU MUST INSTALL AND RUN UPDATEERAM BEFORE YOU LOAD AND RUN * * *
 ' * * * * *  VERSION 3.52. PLEASE SEE UPDATEERAM.BAS FOR COMPLETE DETAILS!  * * * * *
 ' * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *



'  ***********************************
'  **** Changes in Version 3.52  ****
'  ***********************************
'---------------------------------------------------------------------

'Fixed minor bug in linking and courtesy tones.

'---------------------------------------------------------------------

'Added COS debouncing, to ignore noise and "non-clean" logic level shift
'of COS lines. This will also be used to provide selectable kerchunk filtering
'in the next rev of the firmware.

'---------------------------------------------------------------------

'Added new DTMF Muting Timer command. This allows you to select the amount of
'time a DTMF digit will mute that port's receiver and, if enabled, generate
'a covertone. As long as digits are entered before this timer times out, muting
'and covertone continue. The range is 10 to 9999 milliseconds (.01 to 9.9 seconds)
'and programmable in 100 millisecond steps.

'*1006xxxx where xxxx is the time in 10's of milliseconds. Examples:

'*1006 1  program timer to 100 milliseconds
'*1006 7  program timer to 700 milliseconds
'*1006 10  program timer to 1 second
'*1006 50  program timer to 5 seconds

'----------------------------------------------------------------------

'Macros now prevent recursive calls when calling other macros. This prevents
'infinite loops if you accidentally program one macro to call one macro,
'which in turn calls the original.

'----------------------------------------------------------------------

'DTMF decoding routines revised and now using hardware interrupts. Redid the
'buffers, so you can now use an automated program and enter up to
'(typically) 30 commands - separated by the DTMF digit D - and they will all
'be processed in order. This also allows for the manual entering of commands
'- also separated by a DTMF D - without having to drop COR each time. If you
'use D, speech is inhibited. Speaking of which, you may enter DTMF during
'speech or CW with complete reliability now.

'----------------------------------------------------------------------

'Major revamp of audio routing routines. This is mostly for internal code
'ease, but it does run more smoothly now.

'----------------------------------------------------------------------

'There is now a reset command. This also checks that the watchdog timer
'is running. The controller must be unlocked in order to access this command
'(any port may be used).

'*207099

'Within 5 seconds of entering the command, the controller will reset and give
'the signon message. If for some reason the watchdog fails, you'll receive the
'message "TIMER NOT SET"

'---------------------------------------------------------------------

'Courtesy tone programming has changed:

'* 31CT DDDD # dddd # TTTT  # tttt # - program Segment 1
'* 32CT DDDD # dddd # TTTT # tttt # - program Segment 2
'* 33CT DDDD # dddd # TTTT # tttt # - program Segment 3
'* 34CT DDDD # dddd # TTTT # tttt # - program Segment 4

'CT is the courtesy tone 1 - 10.

'Each parameter must be separated by a #

'DDDD is the delay in milliseconds from COS closure to that segment
'dddd is the duration in milliseconds of segment
'TTTT is Tone 1 in hertz
'tttt is Tone 2 in hertz

'Examples:

'Courtesy Tone 1 segment 1, 250 ms delay to start, duration 100 ms, Tone 1
'is 880 hz and Tone 2 is 660 hz.

'*3101 250# 100#  880#  660#

'Courtesy Tone 4, segment 2, 75 ms delay from segment 1, duration 90 ms,
'Tone 1 is 800 hz and Tone 2 is 0 hertz.

'*3204 75# 90#  880#  0#

'----------------------------------------------------------------------------

'Scheduler programming has been changed.
'Added weekends and weekdays to the days of the week.

'*4001 ss dow hours minutes macro

'ss = setpoint # 01 - 40 (must be 2 digits)
'dow = day of week (must be 1 digit)
'hours = 0 to 24 or "0A" for wildcard (must be 2 digits)
'minutes = 00 - 59 (must be 2 digits)
'macro = and valid macro 1 - 40 or 201 - 240 (must be 2 digits)

'New Days of Week list:

'1 - Monday
'2 - Tuesday
'3 - Wednesday
'4 - Thursday
'5 - Friday
'6 - Saturday
'7 - Sunday
'8 - weekdays (12 AM Monday to midnight Friday)
'9 - weekend (12 AM Friday to midnight Sunday)
'0 - everyday

'---------------------------------------------------------------------------
'New Macro erase command added:

'*4003 mm  Erase Macro mm 01 - 40

'---------------------------------------------------------------------------

'Added Calendar function, to readback the set date.

'1101 is the default read code

'*2063 is the programming command to change the read code

'When you program the date, it is read back as confirmation
'When you program the clock, the time is read back as confirmation

'---------------------------------------------------------------------------

'Added more functions to be used in macros. These were necessary to allow
'schedular speech messages to be suspended. This is needed to allow the
'automatic suspension of previously defined setpoints that cause speech, for
'example.. on the hour, every hour. See manual for complete explanation and
'other details.

'151 - 170 Suspend the next scheduler Setpoint occurance 1 - 20
'171 - 190 Restart the next scheduler Setpoint occurance 1 - 20

---------------------------------------------------------------------------